﻿using System;
using System.IO;
using System.Web;

namespace FileDown
{
    /// <summary>
    /// 服务器往输出流里面写数据
    /// </summary>
    public class Handle : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            HttpResponse response = context.Response;
            HttpRequest request = context.Request;
            FileStream fileStream = null;
            byte[] buffer = new Byte[10240];
            int length;

            // 剩余的字节大小
            // 因为这里采取的是每次写入10240字节到输出流中
            long readToData;
            try
            {
                string filename = "CLR via CSharp 3rd edition.pdf"; //通过解密得到文件名

                string filepath = HttpContext.Current.Server.MapPath("~/") + "Resources/" + filename; //待下载的文件路径

                fileStream = new FileStream(filepath, FileMode.Open,FileAccess.Read, FileShare.Read);
                readToData = fileStream.Length;
                while (readToData > 0)
                {
                    // 实际读取的字节大小
                    length = fileStream.Read(buffer, 0, buffer.Length);
                    // 把读取到的字节写入输出流中
                    response.OutputStream.Write(buffer, 0, length);
                    response.Flush();
                    readToData = readToData - length;
                }
            }
            catch (Exception ex)
            {
                response.Write("Error:" + ex.Message);
            }
            finally
            {
                if (fileStream != null)
                {
                    fileStream.Close();
                }

                response.End();
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}