﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Threading;
using System.Windows.Forms;

namespace RequestClient
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public static string url = "http://localhost:17203/Handle.ashx";

        private void button1_Click(object sender, EventArgs e)
        {
            // 从线程池中获得一个线程来处理客户端请求,这样就不会阻塞主线程
            // 这里也可以使用TaskFactory.StartNew(action,cancellationToken) 方式异步调用方法
            ThreadPool.QueueUserWorkItem(DownLoad);
          
            // 如果使用单线程，这样就会阻塞主线程
            // 界面上的TestBoox就是验证主线程是否阻塞的一个控件
            // 当不用线程池线程去执行方法时，界面上的textbox就不能获取焦点
            ////DownLoad(null);
        }

        public void DownLoad(object state)
        {
            // 计时对象
            Stopwatch sw = Stopwatch.StartNew();

            HttpWebRequest request;
            HttpWebResponse response;
            Stream stream;

            // 下载下来的保存的地址
            string savepath = "D:\\Download.pdf";
            FileStream savestream = new FileStream(savepath, FileMode.OpenOrCreate);
            try
            {
                // 发出请求
                request = (HttpWebRequest)HttpWebRequest.Create(url);

                // 获得回应对象
                response = (HttpWebResponse)request.GetResponse();

                // 获得回应流
                stream = response.GetResponseStream();
                byte[] bytes = new byte[10240];
                int readsize;

                // 每次都读取10240字节
                // 采用的是同步读取方法
                // 计算耗费的时间             
                readsize = stream.Read(bytes, 0, bytes.Length);
                while (readsize > 0)
                {
                    savestream.Write(bytes, 0, readsize);
                    readsize = stream.Read(bytes, 0, bytes.Length);
                }

                sw.Stop();
                MessageBox.Show("下载耗时为：" + sw.Elapsed.ToString(), "提示");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error");
            }
            finally
            {
                savestream.Close();
            }
        }
    }
}
